#ifndef BLOCK_H
#define BLOCK_H

// An instance of Block represents a block of messages in the DEM file.

// This class merely presents a stream-like view of the block -- the more
// sophisticated interpretation is done in engine.cpp.

typedef unsigned char byte;

class Block
{
public:
	       Block();

	void   SetBlockTime(float Time);
	float  GetBlockTime();
	void   Reset();

	byte   GetByte();
	short  GetShort();
	long   GetLong();
	float  GetFloat();
	void   GetString();

	void   PutByte(byte c);
	void   PutShort(short c);
	void   PutLong(long c);
	void   PutFloat(float c);
	void   PutString();

	void   Write(ofstream& output);
	void   Read(ifstream& input);

	long   m_size;
	char*  m_buffptr;
	char   m_buffer[5000];
	float* m_pTime; // <- XXX I'll be happier when I
	                //    understand what this is for!
};

#endif
