#include "remstud.h"

inline bool is_ws(char c) { return c == ' '; }

void
splitonws(string& line, lii& words)
{
	string::iterator it = line.begin(), it2;
	string::iterator e = line.end();

	while (it != e) {
		while (it != e && is_ws(*it)) {
			++it;
		}
		if (it == e) return;

		it2 = it;
		while (it != e && !is_ws(*it)) {
			++it;
		}
		words.push_back(make_pair(it2, it));
	}
}

// XXX error checking?  what's that?
int
CamFile::ReadLine(ifstream& input)
{
	float com_time;
	lii tokens;
	string line;
	string command;

	getline(input, line);

	if (line.empty()) {
		if (input.eof()) {
			return 0;
		} else {
			return 1;
		}
	}

	if (*line.rbegin() == '\r')
		line.resize(line.size() - 1);

// 	cout << line << endl;

	line = string(line.begin(), find(line.begin(), line.end(), '#'));

	splitonws(line, tokens);

	if (tokens.empty())
		return 1;

// 	for (lii::iterator it = tokens.begin(); it != tokens.end(); ++it) {
// 		cout << string(it->first, it->second) << endl;
// 	}

	com_time = (float)atof(pop_first_word(tokens).c_str());

	command = pop_first_word(tokens);

	// here goes the logical code and not the string analysing shit

	if (command == "stay" || command == "move" ||
	    command == "spin" || command == "cut") {
		if (!m_movement.empty() && m_movement.back().end_time == 0)
		{
			m_movement.back().end_time = com_time;
		}
		Command com;
		com.m_coord.from_strings(tokens);
		com.type = command;
		com.m_time = com_time;
		com.end_time = 0;
		m_movement.push_back(com);
	}
	else if (command == "view" || command == "turn" || command == "pan")
	{
		if (!m_target.empty() && m_target.back().end_time == 0)
		{
			m_target.back().end_time = com_time;
		}
		Command com;
		com.m_coord.from_strings(tokens);
		com.type = command;
		com.m_time = com_time;
		com.end_time = 0;
		m_target.push_back(com);
	}
	else if (command == "roll" || command == "lean")
	{
		Command com;
		com.data = (float)atof(pop_first_word(tokens).c_str());
		com.type = command;
		com.m_time = com_time;
		com.end_time = 0;
		if (!m_roll.empty() && m_roll.back().end_time == 0)
		{
			m_roll.back().end_time = com_time;
			if ((m_roll.back().data - com.data) > 180)
				com.data += 360;
			if ((m_roll.back().data - com.data) < -180)
				com.data -= 360;
		}
		m_roll.push_back(com);
	}
	else if (command == "palette" || command == "fade")
	{
		Command com;
		com.R = com.G = com.B = com.data = 0;
		com.m_time = com_time;
		com.end_time = 0;
		com.type = command;
		// XXX this section isn't right!
		com.data = atoi(pop_first_word(tokens).c_str());

		if (!tokens.empty())
		{
			com.R = atoi(pop_first_word(tokens).c_str());
			com.G = atoi(pop_first_word(tokens).c_str());
			com.B = atoi(pop_first_word(tokens).c_str());
		}

		if (!m_palette.empty() && m_palette.back().end_time == 0)
		{
			m_palette.back().end_time = com_time;
		}
		m_palette.push_back(com);
	}
	else if (command == "text")
	{
		Command com;

		com.m_time = com_time;
		com.type = pop_first_word(tokens);

		string::iterator c = tokens.front().first;

		do ; while (*c++ != '"');

		do {
			if (*c == '\\') {
				++c;
				if (*c == '\\')     com.text.push_back('\\');
				else if (*c == 'n') com.text.push_back('\n');
				else if (*c == '"') com.text.push_back('"');
			} else {
				com.text.push_back(*c);
			}
			++c;
		} while (*c != '"');

		m_misc.push_back(com);
	}
	else if (command == "subtitle")
	{
		Command com;
		com.m_time = com_time;
		string::iterator c = tokens.front().first;

		com.text += string("alias subtitle echo \"");

		com.type = "stufftext";

		do ; while (*c++ != '"');

		do {
			if (*c == '\\') {
				++c;
				if (*c == '\\')     com.text.push_back('\\');
				else if (*c == 'n') com.text.push_back('\n');
				else if (*c == '"') com.text.push_back('"');
			} else {
				com.text.push_back(*c);
			}
			++c;
		} while (*c != '"');

		com.text += string("\";\nprint_subtitle\n");

		m_misc.push_back(com);
	}
	else if (command == "sound") // XXX clean this shit up
	{
		Command com;
		com.m_time = com_time;
		com.end_time = 449;
		com.type = "sound";
		char* filename;
		filename = &*tokens.front().first;
		if (filename[0] != '\"')
		{
			if (filename[0] == 'p')
				com.end_time = 1;
			else
				com.end_time = (float)atoi (filename+1);
			do
				filename++;
			while (*filename != '"');
		}
		filename++;
		char *c = filename;
		do
			c++;
		while (*c != '"');
		*c = '\0';
		c++;
		com.text = filename;
		com.text += ".wav";
		com.R = 1; // attenuation
		com.G = 1; // volume
		com.B = 0; // channel
		while (*c != '\0')
		{
			while (*c && *c != ' ')
				c++;
			if (*c)
				c++;
			switch (*c)
			{
			case 'a':
				com.R = (float)atof(c+1);
			break;
			case 'v':
				com.G = (float)atof(c+1);
			break;
			case 'c':
				com.B = (float)atof(c+1);
			break;
			}
		}
		m_misc.push_back(com);
	}
	else if (command == "end")
	{
		string ended = pop_first_word(tokens);

		if ((ended == "move" || ended == "spin") && !m_movement.empty())
		{
			m_movement.back().end_time = com_time;
		}
		else if ((ended == "pan" || ended == "turn") && !m_target.empty())
		{
			m_target.back().end_time = com_time;
		}
		else if (ended == "fade" && !m_palette.empty())
		{
			m_palette.back().end_time = com_time;
		}
		else if (ended == "roll" && !m_roll.empty())
		{
			m_roll.back().end_time = com_time;
		}
	}
	else if (command == "eyes")
	{
		int Who;

		if (tokens.empty())
		{
			Who = 1;
		}
		else
		{
			Who = atoi(pop_first_word(tokens).c_str());
		}

		Command com;
		com.type = "eyes";
		com.m_time = com_time;
		com.data = (float)(Who*100);
		m_misc.push_back(com);
	}
	else if (command == "timescale")
	{
		float Scale;
		Scale = (float)(1.0 / atof(pop_first_word(tokens).c_str()));
		Command com;
		com.type = "timescale";
		com.m_time = com_time;
		com.data = Scale;
		m_misc.push_back(com);
	}
	else if (command == "qdqtimescale")
	{
		float Scale;
		Scale = (float)(1.0 / atof(pop_first_word(tokens).c_str()));
		Command com;
		com.type = "qdqtimescale";
		com.m_time = com_time;
		com.data = Scale;
		m_misc.push_back(com);
	}

	return 1;
}
