#ifndef CAMFILE_H
#define CAMFILE_H

// A CamFile collects all the commands from a cam files, separated into
// various categories.

typedef list< pair<string::iterator, string::iterator> > lii;

inline string pop_first_word(lii& l)
{
	string s(l.front().first, l.front().second);
	l.pop_front();
	return s;
}

class CamFile
{
public:
//	CamFile();

	int     ReadLine(ifstream& camfile);

	// Everything interesting that this program does is done in this
	// function (implemented in engine.cpp!) or in RemStudioApp::Go():
	void    Process(Block& src, Block& dst);

        CmdList m_roll;
        CmdList m_palette;
        CmdList m_target;
	CmdList m_movement;
	CmdList m_misc;
};

#endif
