#include "remstud.h"

bool ReadModels = false;
const int FOV = 90*90;
Coord old_pos;
Coord pos;
Coord old_targ;
Coord targ;
float old_pal[4];
float pal[4];
float old_lean;
bool must_items = false;
bool on_view = true;
Command* com;
CamFile camfile;

EntPosList positions[MAX_ENTITIES];
bool interest[450];
bool turning;
bool debug = false;
bool problems = false;
float exittime = 0;
vec3_t camera;
vec3_t cam_pos;
vec3_t targ_pos;
char buffer[0x800];
bool refilming;
float cur_time;
float last_frame_time;
float frame_time=0;
float scale = 1;
float qdqscale = 1;
float inter_time = 0;
float printed_time = 0;
int cur_view=0;

char* sounds [256];
char* models [256];
char level[30];
int health;
int sound_num;
int model_num;
//int i;
int Entity;

static char* itoa(int val, char* buffer, int radix)
{
	assert(radix == 10);
	sprintf(buffer, "%d", val);
	return buffer;
}

void vec2ang (vec3_t src, vec3_t dst,vec3_t angles)
{
	float dx = dst[0] - src[0];
	float dy = dst[1] - src[1];
	float dz = dst[2] - src[2];
	float r = (float)sqrt(dx * dx + dy * dy);
	angles[0] = (float)(atan2 (dz,r) * 180 / 3.14);
	angles[1] = (float)(atan2 (dy,-dx) * -180 / 3.14);
	if (debug)
	{
		angles[0] = -angles[0];
		angles[1] += 180;
	}
}


/*istream& operator>> (istream& instream, CString str)
{
	char buffer[800];
	instream >> buffer;
	str = buffer;
	return instream;
}*/

void
CamFile::Process(Block& src, Block& dst)
{
	// take care of movement
	pos.value(cam_pos);
	if (!this->m_movement.empty() )
	{
		float t = this->m_movement.front().m_time;
		if (t <= cur_time)
		{
			if ((this->m_movement.front().type == "move" &&
				this->m_movement.front().end_time < cur_time) ||
				(this->m_movement.front().type == "spin" &&
				this->m_movement.front().end_time < cur_time) ||
				(this->m_movement.front().type == "cut" ||
				this->m_movement.front().type == "stay"))
			{
				pos = old_pos = this->m_movement.front().m_coord;
				pos.value(cam_pos);
				this->m_movement.pop_front();
			}


			else
			{
				if (this->m_movement.front().m_coord.entity[0] == -1)
				{
					this->m_movement.front().m_coord.offset[0] += cam_pos[0];
					this->m_movement.front().m_coord.entity[0] = 0;
				}
				if (this->m_movement.front().m_coord.entity[1] == -1)
				{
					this->m_movement.front().m_coord.offset[1] += cam_pos[1];
					this->m_movement.front().m_coord.entity[1] = 0;
				}
				if (this->m_movement.front().m_coord.entity[2] == -1)
				{
					this->m_movement.front().m_coord.offset[2] += cam_pos[2];
					this->m_movement.front().m_coord.entity[2] = 0;
				}

				vec3_t a,b;
				old_pos.value(a);
				this->m_movement.front().m_coord.value(b);
				float f = (cur_time - this->m_movement.front().m_time )/
					(this->m_movement.front().end_time - this->m_movement.front().m_time );
				if (f>1)
					f = 1;
				if (f<0)
					f = 0;
				if (this->m_movement.front().type == "move")
				{
					for (int i = 0; i<3;i++)
						cam_pos[i] = a[i] + f*(b[i]-a[i]);
				}
				else // spin, here we go
				{
					// Z, nothing to think about
					cam_pos[2] = a[2] + f*(b[2]-a[2]);

					float ra = sqrt((a[0] - targ_pos[0]) * (a[0] - targ_pos[0]) +
						            (a[1] - targ_pos[1]) * (a[1] - targ_pos[1]));

					float rb = sqrt((b[0] - targ_pos[0]) * (b[0] - targ_pos[0]) +
						            (b[1] - targ_pos[1]) * (b[1] - targ_pos[1]));


					vec3_t aa,ab;
					vec2ang (targ_pos,a,aa);
					vec2ang (targ_pos,b,ab);
					float ang = aa[2] + f* (ab[2]-aa[2]);
					float r = ra + f*(rb - ra);
					cam_pos[0] = targ_pos[0] + cos(ang)* r;
					cam_pos[1] = targ_pos[1] + sin(ang)* r;

//					cam_pos[0] = a[0] + f*(b[0]-a[0]);
//					cam_pos[1] = a[1] + f*(b[1]-a[1]);

/*					for (int i = 0; i<3;i++)
						cam_pos[i] = a[i] + f*(b[i]-a[i]);*/
				}
			}

		}
	}

	// take care of target

	if (on_view && !cur_view)
		targ.value(targ_pos);
	if (debug)
	{
		targ_pos[0] = cam_pos[0];
		targ_pos[1] = cam_pos[1];
		targ_pos[2] = cam_pos[2];
	}
	if (!turning)
	{
		vec2ang (targ_pos,cam_pos,camera);
	}
	turning = false;
	if (!this->m_target.empty() )
	{
		float t = this->m_target.front().m_time;
		if (t <= cur_time)
		{
			if (this->m_target.front().type == "view")
			{
				on_view = true;
				if (this->m_target.front().m_coord.entity[0] == -1)
				// something like "move now now now-300"
				{	// translate it to and absolute position
					this->m_target.front().m_coord.offset[0] += targ_pos[0];
					this->m_target.front().m_coord.offset[1] += targ_pos[1];
					this->m_target.front().m_coord.offset[2] += targ_pos[2];
					this->m_target.front().m_coord.entity[0] = 0;
					this->m_target.front().m_coord.entity[1] = 0;
					this->m_target.front().m_coord.entity[2] = 0;
				}
				targ = this->m_target.front().m_coord;
				old_targ = this->m_target.front().m_coord;
				this->m_target.pop_front();
			}
			else if (this->m_target.front().type == "pan")
			{
				on_view = false;
				vec3_t a,b;
				old_targ.value(a);
				this->m_target.front().m_coord.value(b);
				float f = (cur_time - this->m_target.front().m_time )/
					(this->m_target.front().end_time - this->m_target.front().m_time );
				if (f>1)
					f = 1;
				for (int i = 0; i<3;i++)
					targ_pos[i] = a[i] + f*(b[i]-a[i]);
//				vec2ang (camera,cam_pos,targ_pos);
				camera[2] = 10;
				if (this->m_target.front().end_time < cur_time)
				{
					on_view = true;
					targ = old_targ = this->m_target.front().m_coord;
					this->m_target.pop_front();
				}
			}
			else // turn
			{
				on_view = false;
				turning = true;
				vec3_t a,b;
				old_targ.value(a);
				this->m_target.front().m_coord.value(b);
				float f = (cur_time - this->m_target.front().m_time )/
					(this->m_target.front().end_time - this->m_target.front().m_time );
				if (f>1)
					f = 1;
				// a
/*
				float dx = cam_pos[0] - a[0];
				float dy = cam_pos[1] - a[1];
				float dz = cam_pos[2] - a[2];
				float r = (float)sqrt(dx * dx + dy * dy);
				camera[0] = (float)(atan2 (dz,r) * 180 / 3.14);
				camera[1] = (float)(atan2 (dy,-dx) * -180 / 3.14);
*/
				vec2ang (a,cam_pos,camera);
				// b
/*				dx = cam_pos[0] - b[0];
				dy = cam_pos[1] - b[1];
				dz = cam_pos[2] - b[2];
				r = (float)sqrt(dx * dx + dy * dy);
				targ_pos[0] = (float)(atan2 (dz,r) * 180 / 3.14);
				targ_pos[1] = (float)(atan2 (dy,-dx) * -180 / 3.14);
*/
				vec2ang (b,cam_pos,targ_pos);
				for (int i = 0; i<2;i++)
					camera[i] = camera[i] + f*(targ_pos[i]-camera[i]);

				if (this->m_target.front().end_time < cur_time)
				{
					on_view = true;
					targ = old_targ = this->m_target.front().m_coord;
					this->m_target.pop_front();
				}
			}

		}
	}
	dst.Reset();
	while (src.m_buffptr < src.m_buffer + src.m_size)
	{
		byte ID = src.GetByte();
		switch (ID)
		{
		case 0x0: // BAD
			dst.PutByte(0x0);
			problems = true;
		break;
		case 0x1: // NOP
			dst.PutByte(0x1);
			problems = true;
		break;
		case 0x2: // Disconnect
			dst.PutByte(0x2);
		break;
		case 0x3: // Updatastat
			dst.PutByte(0x3);
			dst.PutByte(src.GetByte()); // index
			dst.PutLong(src.GetLong()); // value
		break;
		case 0x4: // version
			dst.PutByte(0x4);
			dst.PutLong(src.GetLong()); // protocol, should be 0x0F
		break;
		case 0x5: // setview
		{
			dst.PutByte(0x5);
			int entity = src.GetShort();
			if (refilming && !debug)
				entity = 449;
			dst.PutShort(entity); // viewentity
		}
		break;
		case 0x6: // sound
		{
			dst.PutByte(0x6);
			byte mask = src.GetByte();
			dst.PutByte(mask);
			if (mask & 0x01)
				dst.PutByte(src.GetByte()); // vol
			if (mask & 0x02)
				dst.PutByte(src.GetByte()); // attenuation

			memcpy(dst.m_buffptr,src.m_buffptr,9);
			dst.m_buffptr += 9;
			dst.m_size += 9;
			src.m_buffptr += 9;
		}
		break;
		case 0x7: // time
		{
			src.m_pTime = (float*)src.m_buffptr;
			dst.PutByte(0x7);
			cur_time = src.GetFloat();

			if (cur_time <= 1.4)
			{
				last_frame_time = (float)1.4;
				frame_time = (float)1.4;
			}
			frame_time += (cur_time - last_frame_time)*scale;
			last_frame_time = cur_time;

//			dst.PutFloat(frame_time);
			dst.PutFloat(cur_time);
// 			if (refilming && cur_time > 2)// XXX && app->m_addtext)
// 			{
// 				app->m_addtext = false;
// 				dst.PutByte(0x08); // printtext
// 				strcpy (buffer,"Run by ");
// 				strcat(buffer,app->m_runner);
// 				strcat(buffer,"\nFilming by ");
// 				strcat(buffer,app->m_filmer);
// 				strcat (buffer,"\n");
// 				dst.PutString();
// 			}
// 			if (refilming && 0/* XXX app->m_print_time */ && (cur_time - printed_time) > 0.1)
// 			{
// 				printed_time = cur_time;
// 				char temp[10];
// 				sprintf(buffer, "%d", (int)(cur_time / 60));
// 				sprintf(temp, "%d", (int)(cur_time / 60));
// 				strcat(buffer, ":");
// 				strcat(buffer,temp);
// 				sprintf(temp, "%d", int((cur_time - (int)(cur_time)%60)*10));
// 				strcat(buffer,".");
// 				strcat(buffer,temp);
// 				dst.PutByte (0x1A); // cprint
// 				dst.PutString();
// 			}
// 			if (refilming && 0/*app->m_addblood*/ && !positions[1].empty() && health < 100)
// 			{
// 				dst.PutByte(0x12); // particle

// 				dst.PutShort((short)(positions[1].front().origin[0]/0.125));
// 				dst.PutShort((short)(positions[1].front().origin[1]/0.125));
// 				dst.PutShort((short)(positions[1].front().origin[2]/0.125));

// 				dst.PutByte (0); // angle..
// 				dst.PutByte (0);
// 				dst.PutByte (5);
// 				dst.PutByte ((100 - health) >> 4);
// 				dst.PutByte (73); // blood
// 			}
		}
		break;
		case 0x8: // print
			src.GetString();
			if (strstr(buffer,"VERSION 1.07 SERVER"))
			{
				must_items = true;
			}
			if (!0/*app->m_remove_text*/)
			{
				dst.PutByte(0x8);
				dst.PutString();
			}
		break;
		case 0x9: // stufftext
			src.GetString();
			if (!0/*app->m_remove_stufftext*/)
			{
				dst.PutByte(0x9);
				dst.PutString();
			}
		break;
		case 0xA: // setangles
			dst.PutByte(0xA);
			memcpy(dst.m_buffptr,src.m_buffptr,3);
			dst.m_buffptr += 3;
			dst.m_size += 3;
			src.m_buffptr += 3;

		break;
		case 0xB: // serverinfo
		{
			ReadModels = true;
			dst.PutByte(0xB);
			dst.PutLong(src.GetLong());//serverversion
			dst.PutByte(src.GetByte()); // maxclients
			dst.PutByte(src.GetByte()); // multi
			src.GetString();
			strcpy(level,buffer);
			dst.PutString(); // map name
			model_num = 1;
			do
			{
				src.GetString();
				if (models[model_num])
					delete[] models[model_num];
				models[model_num++] = strdup(buffer);
				dst.PutString(); // models
			} while (*buffer);

			sound_num = 1;
			do
			{
				src.GetString();

				if (sounds[sound_num])
					delete[] sounds[sound_num];
				sounds[sound_num++] = strdup(buffer);
				dst.PutString(); // sound
			} while (*buffer);

			CmdList::iterator pos = this->m_misc.begin();
			while (pos != this->m_misc.end())
			{
				string a = pos->type;
				if (a == "sound")
				{
					int i;
					for (i = 1;i<sound_num;i++)
					{
						if (sounds[i] == pos->text)
							break;
					}
					if (i == sound_num)
					{
						sounds[sound_num++] = strdup(pos->text.c_str());
						dst.m_buffptr--;
						dst.m_size--;
						strcpy(buffer,sounds[i]);
						dst.PutString();
						strcpy(buffer,"");
						dst.PutString();
						i--;
					}
					pos->data = (float)i;
				}
				++pos;
			}
		}
		break;
		case 0xC: // lightstyle
			dst.PutByte(0xC);
			dst.PutByte(src.GetByte()); // style#
			src.GetString();
			dst.PutString();
		break;
		case 0xD: // updatename
			dst.PutByte(0xD);
			dst.PutByte(src.GetByte()); // player#
			src.GetString();// name
			dst.PutString();
		break;
		case 0xE: // updatefrags
			dst.PutByte(0xE);
			dst.PutByte(src.GetByte()); // player#
			dst.PutShort(src.GetShort()); // frags#
		break;
		case 0xF: // clientdata
			dst.PutByte(0xF);
			{
				short mask;
				dst.PutShort (mask = src.GetShort());
				if (mask & 0x0001)
				{
					byte view_ofs_z = src.GetByte();
					if (refilming)
						view_ofs_z = 0;
					dst.PutByte (view_ofs_z);
				}
				if (mask & 0x0002)
				{
					byte ang_ofs_1 = src.GetByte();
					if (refilming)
						ang_ofs_1 = 0;
					dst.PutByte (ang_ofs_1);//ang_ofs_1
				}
				if (mask & 0x0004)
					dst.PutByte (src.GetByte());//angles[0]
				if (mask & 0x0020)
				{
					byte vel_x = src.GetByte();
					if (refilming)
						vel_x = 0;
					dst.PutByte (vel_x);//vel[0]
				}
				if (mask & 0x0008)
					dst.PutByte (src.GetByte());//angles[1]
				if (mask & 0x0040)
				{
					byte vel_y = src.GetByte();
					if (refilming)
						vel_y = 0;
					dst.PutByte (vel_y);//vel[1]
				}
				if (mask & 0x0010)
				{
					byte ang_z = src.GetByte();
					if (refilming)
						ang_z = 0;
					dst.PutByte (ang_z);	//angles[2]
				}
				if (mask & 0x0080)
				{
					byte vel_z = src.GetByte();
					if (refilming)
						vel_z = 0;
					dst.PutByte (vel_z);//vel[2]
				}
				if (mask & 0x0200 || must_items)
					dst.PutLong (src.GetLong());//items
				if (mask & 0x1000)
					dst.PutByte (src.GetByte());//weaponframe
				if (mask & 0x2000)
					dst.PutByte (src.GetByte());//armorvalue
				if (mask & 0x4000)
					if (refilming)
					{
						src.GetByte();
						dst.PutByte(0);
					}
					else
						dst.PutByte (src.GetByte());//weaponmodel

				dst.PutShort(health = src.GetShort()); // health
				dst.PutByte (src.GetByte());//currentammo
				dst.PutByte (src.GetByte());//ammo shells
				dst.PutByte (src.GetByte());//ammo nails
				dst.PutByte (src.GetByte());//ammo rockets
				dst.PutByte (src.GetByte());//ammo cells
				dst.PutByte (src.GetByte());//weapon

				if (refilming)
				{
					dst.PutByte(31+128);
					dst.PutByte(64+3);
					dst.PutShort(449);
					dst.PutShort((short)(cam_pos[0] / 0.125));
					dst.PutByte((byte)(camera[0] * 256 / 360));
					dst.PutShort((short)(cam_pos[1] / 0.125));
					dst.PutByte((byte)(camera[1] * 256 / 360));
					dst.PutShort((short)(cam_pos[2] / 0.125));
					dst.PutByte((byte)(camera[2] * 256 / 360));
/*
					dst.PutByte(15+128);
					dst.PutByte(64);
					dst.PutShort(449);
					dst.PutShort((short)(cam_pos[0] / 0.125));
					dst.PutShort((short)(cam_pos[1] / 0.125));
					dst.PutShort((short)(cam_pos[2] / 0.125));
*/
				}
			}
		break;
		case 0x10: // stopsound
			dst.PutByte(0x10);
			dst.PutShort(src.GetShort()); // ???
		break;
		case 0x11: // updatecolor
		{
			dst.PutByte(0x11);
			byte player = src.GetByte();
			byte color = src.GetByte();
			dst.PutByte(player); // player#
// 			if (app->m_color && player == 0)
// 				color = app->m_shirt.GetCurSel() * 16 + app->m_pants.GetCurSel();
			dst.PutByte(color);
		}
		break;
		case 0x12: // particle
			dst.PutByte(0x12);
			memcpy(dst.m_buffptr,src.m_buffptr,11);
			dst.m_buffptr += 11;
			dst.m_size += 11;
			src.m_buffptr += 11;
		break;

		case 0x13: // damage
			dst.PutByte(0x13);
			dst.PutByte(src.GetByte()); // save
			dst.PutByte(src.GetByte()); // take
			dst.PutShort(src.GetShort()); //origin
			dst.PutShort(src.GetShort());
			dst.PutShort(src.GetShort());
		break;
		case 0x14: // spawnstatic
			dst.PutByte(0x14);
			memcpy(dst.m_buffptr,src.m_buffptr,13);
			dst.m_buffptr += 13;
			dst.m_size += 13;
			src.m_buffptr += 13;
		break;
		case 0x15: // spawnbinary
			dst.PutByte(0x15);
		break;
		case 0x16: // spawnbaseline
			dst.PutByte(0x16);
			dst.PutShort(src.GetShort()); // entity
			dst.PutByte(src.GetByte()); // modelindex
			dst.PutByte(src.GetByte()); // frame
			dst.PutByte(src.GetByte()); // colormap
			dst.PutByte(src.GetByte()); // skin
			int i;
			for (i = 0;i < 3;i++)
			{
				dst.PutShort(src.GetShort()); // coord
				dst.PutByte(src.GetByte()); // angle
			}

		break;
		case 0x17: // temp_entity
		{
			int i;
			dst.PutByte(0x17);
			byte type = src.GetByte();
			dst.PutByte(type);
			switch (type)
			{
			case 0:
			case 1:
			case 2:
			case 3:
			case 4:
			case 7:
			case 8:
			case 10:
			case 11:
				for (i = 0;i < 3;i++)
				{
					dst.PutShort(src.GetShort()); // coord
				}
			break;
			case 5:
			case 6:
			case 9:
				dst.PutShort(src.GetShort()); // entity #
				for (i = 0;i < 3;i++)
				{
					dst.PutShort(src.GetShort()); // coord
					dst.PutShort(src.GetShort()); // end coord
				}
			break;
			}
		}
		break;
		case 0x18: // setpause
			dst.PutByte(0x18);
			dst.PutByte(src.GetByte()); // pausestate
		break;
		case 0x19: // signonum
		{
			byte signon = src.GetByte();
			if (signon == 2) // preswpawn (?)
			{
				dst.PutByte(0x16); // spawnbaseline
				dst.PutShort(449);
				dst.PutByte(1);//model (!!!)
				dst.PutByte(0);//frame
				dst.PutByte(0);//color
				dst.PutByte(0);//skin
				if (!this->m_movement.empty())
				{
					vec3_t vec;
					this->m_movement.front().m_coord.value(vec);
					dst.PutShort((short)vec[0]); // coord
					dst.PutByte(0); // angle
					dst.PutShort((short)vec[1]); // coord
					dst.PutByte(0);
					dst.PutShort((short)vec[2]); // coord
					dst.PutByte(0);
				}
				else
				{
					dst.PutShort(0); // coord
					dst.PutByte(0); // angle
					dst.PutShort(0); // coord
					dst.PutByte(0);
					dst.PutShort(0); // coord
					dst.PutByte(0);
				}

/*				dst.PutByte(0x09); // stufftext;
				strcpy(buffer,"r_drawviewmodel 0\n");
				dst.PutString();
*/
/*				dst.PutByte(0x09); // stufftext;
				strcpy(buffer,"viewsize 120\n");
				dst.PutString();
*/
				dst.PutByte(0x09); // stufftext;
				strcpy(buffer,"v_cshift 0 0 0 0\n");
				dst.PutString();
			}
			dst.PutByte(0x19); // signonum
			dst.PutByte(signon);
		}
		break;
		case 0x1A: // centerprint
			src.GetString();
			if (!0/*app->m_remove_cprint*/)
			{
				dst.PutByte(0x1A);
				dst.PutString();
			}
		break;
		case 0x1B: // killedmonster
			dst.PutByte(0x1B);
		break;
		case 0x1C: // foundsecret
			dst.PutByte(0x1C);
		break;
		case 0x1D: // spawnstaticsound
			dst.PutByte(0x1D);
			// 3 coords
			dst.PutShort(src.GetShort()); // coord
			dst.PutShort(src.GetShort()); // coord
			dst.PutShort(src.GetShort()); // coord

			dst.PutByte(src.GetByte()); // soundnum
			dst.PutByte(src.GetByte()); // volume
			dst.PutByte(src.GetByte()); // attenuation
		break;
		case 0x1E: // intermission
			dst.PutByte(0x1E);
			refilming = false;
			exittime = inter_time = cur_time;
			dst.PutByte(0x5); // setview
			dst.PutShort(1);
		break;
		case 0x1F: // finale
			dst.PutByte(0x1F);
			src.GetString();
			dst.PutString();
			refilming = false;
		break;
		case 0x20: // cdtrack
			dst.PutByte(0x20);
			dst.PutByte(src.GetByte()); // fromtrack
			dst.PutByte(src.GetByte()); // totrack
		break;
		case 0x21: // sellscreen
			dst.PutByte(0x21);
		break;
		default: // updateentity
		{
			char* pointer = dst.m_buffptr;
			dst.PutByte(ID);
			short mask = ID & 0x07F;
			if (mask&0x0001)
			{
				byte temp = src.GetByte();
				dst.PutByte(temp);
				mask |= (temp << 8);
			}
//	int entity;
			if (mask & 0x4000)
			{
				Entity = src.GetShort();
				dst.PutShort(Entity);
			}
			else
			{
				Entity = src.GetByte();
				dst.PutByte(Entity);
			}
			// check fov somewhere here
			vec3_t origin = {0,0,0};

			vec3_t angles;
			short ts;
			byte tb;
			if (mask&0x0400)
				dst.PutByte(src.GetByte()); // modelindex
			if (mask&0x0040)
				dst.PutByte(src.GetByte()); // frame
			if (mask&0x0800)
				dst.PutByte(src.GetByte()); // colormap
			if (mask&0x1000)
				dst.PutByte(src.GetByte()); // skin
			if (mask&0x2000)
				dst.PutByte(src.GetByte()); // attackstate
			if (mask&0x0002)
			{
				ts = src.GetShort();
				origin[0] = (short)(ts * 0.125);
				dst.PutShort(ts);
			}
			if (mask&0x0100)
			{
				tb = src.GetByte();
				angles[0] = ((float)tb * 360) / 256;
				dst.PutByte(tb);
			}
			if (mask&0x0004)
			{
				ts = src.GetShort();
				origin[1] = (float)(ts * 0.125);
				dst.PutShort(ts);
			}
			if (mask&0x0010)
			{
				tb = src.GetByte();
				angles[1] = (float)tb * 360 / 256;
				dst.PutByte(tb);
			}
			if (mask&0x0008)
			{
				ts = src.GetShort();
				origin[2] = (float)(ts * 0.125);
				dst.PutShort(ts);
			}
			if (mask&0x0200)
			{
				tb = src.GetByte();
				angles[2] = (float)tb * 360 / 256;
				dst.PutByte(tb);
			}
			if (Entity < 450 && Entity > 0 && interest[Entity] )
			{
				positions[Entity].push_front(EntPos(cur_time,origin));
			}
			if (Entity == cur_view)
			{
				camera[0] = angles[0];
				camera[1] = angles[1];
				camera[2] = angles[2];
			}
			if (/*app->m_minusv*/0 && (origin[0] != 0
								|| origin[1] != 0
								|| origin[2] != 0 ) && refilming)
			{

				float dx = origin[0] - cam_pos[0];
				float dy = origin[1] - cam_pos[1];
				//float dz = origin[2] - cam_pos[2];
				float r = (float)sqrt(dx * dx + dy * dy);

				vec2ang (origin,cam_pos,angles);

				float da1 = angles[1] - camera[1];
				float da2 = angles[0] - camera[0];

				if (da1 > 180)
					da1 -= 360;
				if (da2 > 180)
					da2 -= 360;
				if (da1 < -180)
					da1 += 360;
				if (da2 < -180)
					da2 += 360;
				// FIXME !!! XXX ??? --mwh
				if (da1*da1 > 6400 && r > 600)
				{
					dst.m_size -= (dst.m_buffptr - pointer);
					dst.m_buffptr = pointer;
				}
			}
		}
		}
	}


	// deal the rolling
	camera[2] = old_lean;
	if (!this->m_roll.empty() )
	{
		float t = this->m_roll.front().m_time;
		if (t <= cur_time)
		{
			if (this->m_roll.front().type == "lean")
			{
				old_lean = camera[2] = this->m_roll.front().data;
				this->m_roll.pop_front();
			}
			else // roll
			{
				float f = (cur_time - this->m_roll.front().m_time )/
					(this->m_roll.front().end_time - this->m_roll.front().m_time );
				if (f>1)
					f = 1;
				camera[2] = old_lean + f*(this->m_roll.front().data - old_lean);
				if (this->m_roll.front().end_time < cur_time)
				{
					camera[2] = old_lean = this->m_roll.front().data;
					this->m_roll.pop_front();
				}
			}
		}
	}

	// deal the palette shifts
	if (!this->m_palette.empty() )
	{
		float t = this->m_palette.front().m_time;
		if (t <= cur_time)
		{
			if (this->m_palette.front().type == "palette" &&
				 this->m_palette.front().data <= 255) // to avoid bad colors
			{
				int i;
				old_pal[0] = this->m_palette.front().R;
				old_pal[1] = this->m_palette.front().G;
				old_pal[2] = this->m_palette.front().B;
				old_pal[3] = this->m_palette.front().data;
				char temp[10];
				dst.PutByte(0x09);// stufftext;
				strcpy (buffer, "v_cshift ");
				for (i = 0;i < 4;i++)
				{
					itoa ((int)old_pal[i],temp,10);
					strcat (buffer,temp);
					strcat (buffer," ");
				}
				strcat (buffer,"\n");
				dst.PutString();

				this->m_palette.pop_front();
			}
			else // fade
			{
				float f = (cur_time - this->m_palette.front().m_time )/
					(this->m_palette.front().end_time - this->m_palette.front().m_time );
				if (f>1)
					f = 1;
				pal[0] = old_pal[0] + f*(this->m_palette.front().R - old_pal[0]);
				pal[1] = old_pal[1] + f*(this->m_palette.front().G - old_pal[1]);
				pal[2] = old_pal[2] + f*(this->m_palette.front().B - old_pal[2]);
				pal[3] = old_pal[3] + f*(this->m_palette.front().data - old_pal[3]);
				if (pal[3] > 255)
					pal[3] = 255;
				char temp[10];
				int i;
				dst.PutByte(0x09);// stufftext;
				strcpy (buffer, "v_cshift ");
				for (i = 0;i < 4;i++)
				{
					itoa ((int)pal[i],temp,10);
					strcat (buffer,temp);
					strcat (buffer," ");
				}
				strcat (buffer,"\n");
				dst.PutString();

				if (this->m_palette.front().end_time < cur_time)
				{
					old_pal[0] = this->m_palette.front().R;
					old_pal[1] = this->m_palette.front().G;
					old_pal[2] = this->m_palette.front().B;
					old_pal[3] = this->m_palette.front().data;
					this->m_palette.pop_front();
				}
			}
		}
	}
	if (!this->m_misc.empty() )
	{
		float t = this->m_misc.front().m_time;
		if (t <= cur_time)
		{
/*			if (this->m_misc.front().type == "print")
			{
				dst.PutByte(0x08);
				strcpy(buffer,LPCSTR(this->m_misc.front().text));
				dst.PutString();
			}
			else if (this->m_misc.front().type == "centerprint")
			{
				dst.PutByte(0x1A);
				strcpy(buffer,LPCSTR(this->m_misc.front().text));
				dst.PutString();
			}
			else if (this->m_misc.front().type == "stufftext")
			{
				dst.PutByte(0x09);
				strcpy(buffer,LPCSTR(this->m_misc.front().text));
				dst.PutString();
			}
			else if (this->m_misc.front().type == "finale")
			{
				dst.PutByte(0x1F);
				strcpy(buffer,LPCSTR(this->m_misc.front().text));
				dst.PutString();
			}
			else */if (this->m_misc.front().type == "eyes")
			{
//				refilming = false;
				dst.PutByte(0x5); // setview
				dst.PutShort((int)(this->m_misc.front().data/100));
				cur_view = (int)(this->m_misc.front().data/100);
				this->m_misc.pop_front();
			}
			else if (this->m_misc.front().type == "timescale")
			{
				scale = this->m_misc.front().data;
				dst.PutByte(0x09);
				sprintf(buffer,"temp1 %f\n",scale);
				dst.PutString();
				this->m_misc.pop_front();
			}
			else if (this->m_misc.front().type == "qdqtimescale")
			{
				qdqscale = this->m_misc.front().data;

				dst.PutByte(0x09);
				dst.PutString();
				this->m_misc.pop_front();
			}
/*			else if (this->m_misc.front().type == "sound")
			{
				byte mask = 0;
				if (this->m_misc.front().G != 1)
					mask |= 1;
				if (this->m_misc.front().R != 2)
					mask |= 2;
				dst.PutByte (0x06);
				dst.PutByte (mask);
				if (mask & 1)
				{
					dst.PutByte ((byte)(this->m_misc.front().G * 255));
				}
				if (mask & 2)
				{
					dst.PutByte ((byte)(this->m_misc.front().R * 64));
				}
				dst.PutShort((short)(this->m_misc.front().end_time*8+this->m_misc.front().B));
				dst.PutByte ((byte)(this->m_misc.front().data));
				vec3_t coord;
				if (this->m_misc.front().end_time==449)
				{
					coord[0] = cam_pos[0];
					coord[1] = cam_pos[1];
					coord[2] = cam_pos[2];
				}
				else if (!positions[(int)(this->m_misc.front().end_time)].empty())
				{
					coord[0] = positions[(int)(this->m_misc.front().end_time)].front().origin[0];
					coord[1] = positions[(int)(this->m_misc.front().end_time)].front().origin[1];
					coord[2] = positions[(int)(this->m_misc.front().end_time)].front().origin[2];
				}
				for (i = 0;i<3;i++)
				{
					dst.PutShort((short)(coord[i]/0.125));
				}
			}*/
		}

	}
/*	{
		float dx = cam_pos[0] - targ_pos[0];
		float dy = cam_pos[1] - targ_pos[1];
		float dz = cam_pos[2] - targ_pos[2];
		float r = (float)sqrt(dx * dx + dy * dy);
		camera[0] = (float)(atan2 (dz,r) * 180 / 3.14);
		camera[1] = (float)(atan2 (dy,-dx) * -180 / 3.14);
		// camera [2] is being dealt above
	}*/

	if (/*app->m_generate &&
	      app->m_exittime && */
		refilming &&
		cur_time > (exittime - 1.7) && exittime > 0)
	{
		strcpy (buffer,"Exact exit time was ");
		char tmp[60];
		if (exittime > 60)
		{
			itoa ((int)(exittime / 60),tmp,10);
			strcat(buffer,tmp);
			strcat(buffer,":");
		}
		itoa ((int)(exittime) % 60,tmp,10);
		strcat(buffer,tmp);
		strcat(buffer,".");
		itoa ((long)((exittime - (int)(exittime)%60)*100000),tmp,10);
		strcat(buffer,tmp);
		strcat(buffer,"\n");
		dst.PutByte (0x08); // print
		dst.PutString();
		exittime = 9999999;
	}
	if (0/*app->m_fade*/ && inter_time != 0)
	{
		int rate = (int)((cur_time - inter_time) * 51);
		if (rate > 255)
			rate = 255;
		char temp[10];
		dst.PutByte(0x09);// stufftext;
		strcpy (buffer, "v_cshift 0 0 0 ");
		strcat (buffer, itoa(rate,temp,10));
		strcat (buffer, "\n");
		dst.PutString();
	}
}
