#include "remstud.h"

extern bool problems;

RemStudioApp::RemStudioApp()
{
	m_dest = "";
	m_script = "";
	m_source = "";
	m_color = false;
	m_addtext = false;
	m_print_time = false;
	m_remove_cprint = true;
	m_remove_text = true;
	m_remove_stufftext = true;
	m_chain = false;
	m_addblood = true;
	m_next = "";
	m_fade = true;
	m_minusv = false;
	m_exittime = true;
	m_runner = "";
	m_filmer = "";
	m_pants = 4;
	m_shirt = 0;

	int I;

	for (I = 0; I < 256; I++)
	{
		sounds[I] = models[I] = 0;
	}
}

bool exists(string filename)
{
	if (filename.empty())
		return false;
	FILE* f = fopen(filename.c_str(), "r");
	if (f)
	{
		fclose(f);
		return true;
	}
	return false;
}

#define WriteBlock(dst, destination) \
	if (dst.m_size)\
		dst.Write(destination);

extern float printed_time;

void
maybe_do_misc(CamFile& camfile, ofstream& destination, Block& dst)
{
	int i;
	if (!camfile.m_misc.empty())
	{
		float t = camfile.m_misc.front().m_time;
		if (t <= cur_time)
		{
			dst.Reset();

			if (camfile.m_misc.front().type == "print")
			{
				dst.PutByte(0x08);
				strcpy(buffer, camfile.m_misc.front().text.c_str());
				dst.PutString();
				camfile.m_misc.pop_front();
			}
			else if (camfile.m_misc.front().type == "centerprint")
			{
				dst.PutByte(0x1A);
				strcpy(buffer, camfile.m_misc.front().text.c_str());
				dst.PutString();
				camfile.m_misc.pop_front();
			}
			else if (camfile.m_misc.front().type == "stufftext")
			{
				dst.PutByte(0x09);
				strcpy(buffer, camfile.m_misc.front().text.c_str());
				dst.PutString();
				camfile.m_misc.pop_front();
			}
			else if (camfile.m_misc.front().type == "finale")
			{
				dst.PutByte(0x1F);
				strcpy(buffer, camfile.m_misc.front().text.c_str());
				dst.PutString();
				camfile.m_misc.pop_front();
			}
			else if (camfile.m_misc.front().type == "sound")
			{
				byte mask = 0;
				if (camfile.m_misc.front().G != 1)
					mask |= 1;
				if (camfile.m_misc.front().R != 2)
					mask |= 2;
				dst.PutByte (0x06);
				dst.PutByte (mask);
				if (mask & 1)
				{
					dst.PutByte ((byte)(camfile.m_misc.front().G * 255));
				}
				if (mask & 2)
				{
					dst.PutByte ((byte)(camfile.m_misc.front().R * 64));
				}
				dst.PutShort((short)(camfile.m_misc.front().end_time*8+camfile.m_misc.front().B));
				dst.PutByte ((byte)(camfile.m_misc.front().data));
				vec3_t coord;
				if (camfile.m_misc.front().end_time==449)
				{
					coord[0] = cam_pos[0];
					coord[1] = cam_pos[1];
					coord[2] = cam_pos[2];
				}
				else if (!positions[(int)(camfile.m_misc.front().end_time)].empty())
				{
					coord[0] = positions[(int)(camfile.m_misc.front().end_time)].front().origin[0];
					coord[1] = positions[(int)(camfile.m_misc.front().end_time)].front().origin[1];
					coord[2] = positions[(int)(camfile.m_misc.front().end_time)].front().origin[2];
				}
				for (i = 0;i<3;i++)
				{
					dst.PutShort((short)(coord[i]/0.125));
				}
				camfile.m_misc.pop_front();

			}
			if (dst.m_size)
				WriteBlock(dst, destination);
		}
	}
}


void RemStudioApp::Go()
{
	int i;
	printed_time = 0;
	refilming = true;
	if (m_source.empty())
	{
// 		MessageBox( "You must specify a source file.",
// 			"Error", MB_ICONEXCLAMATION | MB_OK);
		return;
	}
	if (m_dest.empty())
	{
// 		MessageBox( "You must specify a destination file.",
// 			"Error", MB_ICONEXCLAMATION | MB_OK);
		return;
	}
	if (!exists(m_source))
	{
// 		MessageBox( "The source file \"" + m_source + "\" doesn't exist",
// 			"Error", MB_ICONEXCLAMATION | MB_OK);
		return;
	}
	if (m_script.empty())
	{
// 		MessageBox( "You must specify a script file",
// 			"Error", MB_ICONEXCLAMATION | MB_OK);
		return;
	}
	if (!exists(m_script))
	{
// 		MessageBox( "The script file \"" + m_script + "\" doesn't exist",
// 			"Error", MB_ICONEXCLAMATION | MB_OK);
		return;
	}

	refilming = true;
	cur_time = 0;

	Block src, dst;
	dst.Reset();
	ifstream source;
	ifstream script;
	ofstream destination;

	for (i = 0 ; i < 450; i++)
		interest[i] = false;

	CamFile camfile;

	script.open(m_script.c_str());
	while (camfile.ReadLine(script)) {}
	script.close();

	OrderList(camfile.m_roll);
	OrderList(camfile.m_palette);
	OrderList(camfile.m_target);
	OrderList(camfile.m_movement);
	OrderList(camfile.m_misc);

	source.open(m_source.c_str(), ifstream::binary);
	destination.open(m_dest.c_str(), ifstream::binary);

	source.unsetf(ifstream::skipws);

	char c = '\n';
	do {
		source >> c;
	} while (c != '\n');

	destination << "-1\n";

	inter_time = 0;
	src.Read(source);
	float old_t = 1.35, t;

	while (strcmp(src.m_buffer,"ABCDEFG") &&
	       ((inter_time == 0 || cur_time < inter_time + 5) || !m_fade))
	{
		t = src.GetBlockTime();
		if (!t || scale == 1)
		{
			camfile.Process(src, dst);
			if (dst.m_size >= 1450); // fixme : treat it XXX what?

			WriteBlock(dst, destination);

			maybe_do_misc(camfile, destination, dst);

			if (t)
				old_t = t;
		}
		else
		{
			// XXX this is probably broken
			float sc = scale;
			if (qdqscale)
				sc = qdqscale;
			while ((t - old_t) > (sc))
			{
				old_t += sc;
				src.SetBlockTime(old_t);
				src.m_buffptr = src.m_buffer;
				camfile.Process(src, dst);
				WriteBlock(dst, destination);
			}
			src.SetBlockTime(t);
			old_t = t;
		}
		camfile.Process(src, dst);
		WriteBlock(dst, destination);

		maybe_do_misc(camfile, destination, dst);

		src.Read(source);
	}

	dst.Reset();
	if (m_chain)
	{
		dst.PutByte(0x09); // stufftext;
		strcpy (buffer,"playdemo ");
		strcat (buffer, m_next.c_str());
		strcat (buffer,"\n");
		dst.PutString();
	}
	dst.PutByte (0x02); // disconnect
	dst.Write(destination);

// 	if (problems)
// 		MessageBox("There were problems refilming " + m_source + " to "
// 						+ m_dest + ". However, the movie may be playable.",
// 						"Done", MB_ICONINFORMATION | MB_OK);
// 	else if (!m_Batch && !m_play)
// 			MessageBox(m_source + " refilmed to "
// 							+ m_dest + " succesfully.",
// 							"Done", MB_ICONINFORMATION | MB_OK);

	source.close();
	script.close();
	destination.close();

	camfile.m_roll.clear();
	camfile.m_palette.clear();
	camfile.m_target.clear();
	camfile.m_movement.clear();
	camfile.m_misc.clear();
}


