#ifndef TEST_H
#define TEST_H

#include <cstdlib>
#include <cstring>
#include <cassert>
#include <cstdio>

#include <string>

using namespace std;

typedef int (*testfunc)(void);

struct testentry 
{
	testfunc func;
	char* name;
};

#define TEST(f) {f, #f}

extern testentry testentries[];

char* fail_thing = "";
int fail_line = -1;

int
fail(int line, char* t)
{
	fail_line = line;
	fail_thing = t;
	return 1;
}

#define ASSERT(thing) do { if (!(thing)) { return fail(__LINE__, #thing); } } while (0)

int
main(int argc, char* argv)
{
	testentry* e = &testentries[0];
	
	int passes = 0;
	int fails = 0;

	while (*e->func)
	{
		if ((*e->func)())
		{
			printf("%s failed, line %d, %s\n", e->name, fail_line, fail_thing);
			fails++;
		}
		else
		{
			passes++;
		}
		e++;
	}

	printf("Ran %d tests with %d passes and %d fails\n", 
	       passes + fails, passes, fails);
	
	return fails != 0;
}

#endif
